diff --git a/web/pgadmin/utils/sqlautocomplete/autocomplete.py b/web/pgadmin/utils/sqlautocomplete/autocomplete.py
index 8a25c13..3efac77 100644
--- a/web/pgadmin/utils/sqlautocomplete/autocomplete.py
+++ b/web/pgadmin/utils/sqlautocomplete/autocomplete.py
@@ -429,158 +927,126 @@ class SQLAutoComplete(object):
         Datatype: get_datatype_matches,
     }
 
-    def populate_scoped_cols(self, scoped_tbls):
-        """ Find all columns in a set of scoped_tables
+    def populate_scoped_cols(self, scoped_tbls, local_tbls=()):
+        """Find all columns in a set of scoped_tables.
+
         :param scoped_tbls: list of TableReference namedtuples
-        :return: list of column names
+        :param local_tbls: tuple(TableMetadata)
+        :return: {TableReference:{colname:ColumnMetaData}}
+
         """
+        ctes = dict((normalize_ref(t.name), t.columns) for t in local_tbls)
+        columns = OrderedDict()
+        meta = self.dbmetadata
+
+        def addcols(schema, rel, alias, reltype, cols):
+            tbl = TableReference(schema, rel, alias, reltype == 'functions')
+            if tbl not in columns:
+                columns[tbl] = []
+            columns[tbl].extend(cols)
 
-        columns = []
         for tbl in scoped_tbls:
-            if tbl.schema:
-                # A fully qualified schema.relname reference
-                schema = self.escape_name(tbl.schema)
+            # Local tables should shadow database tables
+            if tbl.schema is None and normalize_ref(tbl.name) in ctes:
+                cols = ctes[normalize_ref(tbl.name)]
+                addcols(None, tbl.name, 'CTE', tbl.alias, cols)
+                continue
+            schemas = [tbl.schema] if tbl.schema else self.search_path
+            for schema in schemas:
                 relname = self.escape_name(tbl.name)
-
+                schema = self.escape_name(schema)
                 if tbl.is_function:
-                    query = render_template(
-                        "/".join([self.sql_path, 'functions.sql']),
-                        schema_name=schema,
-                        func_name=relname
-                    )
-
-                    if self.conn.connected():
-                        status, res = self.conn.execute_dict(query)
-                        func = None
-                        if status:
-                            for row in res['rows']:
-                                func = FunctionMetadata(
-                                    row['schema_name'], row['func_name'],
-                                    row['arg_list'], row['return_type'],
-                                    row['is_aggregate'], row['is_window'],
-                                    row['is_set_returning']
-                                )
-                        if func:
-                            columns.extend(func.fieldnames())
+                    # Return column names from a set-returning function
+                    # Get an array of FunctionMetadata objects
+                    functions = meta['functions'].get(schema, {}).get(relname)
+                    for func in (functions or []):
+                        # func is a FunctionMetadata object
+                        cols = func.fields()
+                        addcols(schema, relname, tbl.alias, 'functions', cols)
                 else:
-                    # We don't know if schema.relname is a table or view. Since
-                    # tables and views cannot share the same name, we can check
-                    # one at a time
-
-                    query = render_template(
-                        "/".join([self.sql_path, 'columns.sql']),
-                        object_name='table',
-                        schema_name=schema,
-                        rel_name=relname
-                    )
-
-                    if self.conn.connected():
-                        status, res = self.conn.execute_dict(query)
-                        if status:
-                            if len(res['rows']) > 0:
-                                # Table exists, so don't bother checking for a
-                                # view
-                                for record in res['rows']:
-                                    columns.append(record['column_name'])
-                            else:
-                                query = render_template(
-                                    "/".join([self.sql_path, 'columns.sql']),
-                                    object_name='view',
-                                    schema_name=schema,
-                                    rel_name=relname
-                                )
-
-                                if self.conn.connected():
-                                    status, res = self.conn.execute_dict(query)
-                                    if status:
-                                        for record in res['rows']:
-                                            columns.append(
-                                                record['column_name'])
-            else:
-                # Schema not specified, so traverse the search path looking for
-                # a table or view that matches. Note that in order to get
-                # proper shadowing behavior, we need to check both views and
-                # tables for each schema before checking the next schema
-                for schema in self.search_path:
-                    relname = self.escape_name(tbl.name)
-
-                    if tbl.is_function:
-                        query = render_template(
-                            "/".join([self.sql_path, 'functions.sql']),
-                            schema_name=schema,
-                            func_name=relname
-                        )
-
-                        if self.conn.connected():
-                            status, res = self.conn.execute_dict(query)
-                            func = None
-                            if status:
-                                for row in res['rows']:
-                                    func = FunctionMetadata(
-                                        row['schema_name'], row['func_name'],
-                                        row['arg_list'], row['return_type'],
-                                        row['is_aggregate'], row['is_window'],
-                                        row['is_set_returning']
-                                    )
-                            if func:
-                                columns.extend(func.fieldnames())
-                    else:
-                        query = render_template(
-                            "/".join([self.sql_path, 'columns.sql']),
-                            object_name='table',
-                            schema_name=schema,
-                            rel_name=relname
-                        )
-
-                        if self.conn.connected():
-                            status, res = self.conn.execute_dict(query)
-                            if status:
-                                if len(res['rows']) > 0:
-                                    # Table exists, so don't bother checking
-                                    # for a view
-                                    for record in res['rows']:
-                                        columns.append(record['column_name'])
-                                else:
-                                    query = render_template(
-                                        "/".join(
-                                            [self.sql_path, 'columns.sql']
-                                        ),
-                                        object_name='view',
-                                        schema_name=schema,
-                                        rel_name=relname
-                                    )
-
-                                    if self.conn.connected():
-                                        status, res = self.conn.execute_dict(
-                                            query
-                                        )
-                                        if status:
-                                            for record in res['rows']:
-                                                columns.append(
-                                                    record['column_name']
-                                                )
+                    for reltype in ('tables', 'views'):
+                        cols = meta[reltype].get(schema, {}).get(relname)
+                        if cols:
+                            cols = cols.values()
+                            addcols(schema, relname, tbl.alias, reltype, cols)
+                            break
 
         return columns
 
+    def _get_schemas(self, obj_typ, schema):
+        """Returns a list of schemas from which to suggest objects.
+
+        :param schema is the schema qualification input by the user (if any)
+
+        """
+        metadata = self.dbmetadata[obj_typ]
+        if schema:
+            schema = self.escape_name(schema)
+            return [schema] if schema in metadata else []
+        return self.search_path if self.search_path_filter else metadata.keys()
+
+    def _maybe_schema(self, schema, parent):
+        return None if parent or schema in self.search_path else schema
+
     def populate_schema_objects(self, schema, obj_type):
+        """Returns a list of SchemaObjects representing tables or views.
+
+        :param schema is the schema qualification input by the user (if any)
+
         """
-        Returns list of tables or functions for a (optional) schema
+        # Fetch the schema objects first
+        self.fetch_schema_objects(schema, obj_type)
+
+        return [
+            SchemaObject(
+                name=obj,
+                schema=(self._maybe_schema(schema=sch, parent=schema))
+            )
+            for sch in self._get_schemas(obj_type, schema)
+            for obj in self.dbmetadata[obj_type][sch].keys()
+        ]
+
+    def populate_functions(self, schema, filter_func):
+        """Returns a list of function SchemaObjects.
+
+        :param filter_func is a function that accepts a FunctionMetadata
+        namedtuple and returns a boolean indicating whether that
+        function should be kept or discarded
 
-        Args:
-            schema:
-            obj_type:
         """
 
+        # Fetch the functions list
+        self.fetch_functions(schema)
+
+        # Because of multiple dispatch, we can have multiple functions
+        # with the same name, which is why `for meta in metas` is necessary
+        # in the comprehensions below
+        return [
+            SchemaObject(
+                name=func,
+                schema=(self._maybe_schema(schema=sch, parent=schema)),
+                meta=meta
+            )
+            for sch in self._get_schemas('functions', schema)
+            for (func, metas) in self.dbmetadata['functions'][sch].items()
+            for meta in metas
+            if filter_func(meta)
+        ]
+
+    def fetch_schema_objects(self, schema, obj_type):
+        """
+        This function is used to fetch schema objects like tables, views, etc..
+        :return:
+        """
         in_clause = ''
         query = ''
-        objects = []
+        data = []
 
         if schema:
             in_clause = '\'' + schema + '\''
         else:
             for r in self.search_path:
                 in_clause += '\'' + r + '\','
-
             # Remove extra comma
             if len(in_clause) > 0:
                 in_clause = in_clause[:-1]
@@ -593,9 +1059,6 @@ class SQLAutoComplete(object):
             query = render_template("/".join([self.sql_path, 'tableview.sql']),
                                     schema_names=in_clause,
                                     object_name='views')
-        elif obj_type == 'functions':
-            query = render_template("/".join([self.sql_path, 'functions.sql']),
-                                    schema_names=in_clause)
         elif obj_type == 'datatypes':
             query = render_template("/".join([self.sql_path, 'datatypes.sql']),
                                     schema_names=in_clause)
@@ -604,342 +1067,118 @@ class SQLAutoComplete(object):
             status, res = self.conn.execute_dict(query)
             if status:
                 for record in res['rows']:
-                    objects.append(record['object_name'])
+                    data.append(
+                        (record['schema_name'], record['object_name'])
+                    )
 
-        return objects
+        if (obj_type == 'tables' or obj_type == 'views') and len(data) > 0:
+            self.extend_relations(data, obj_type)
+            self.extend_columns(
+                self.fetch_columns(in_clause, obj_type), obj_type
+            )
+            if obj_type == 'tables':
+                self.extend_foreignkeys(
+                    self.fetch_foreign_keys(in_clause, obj_type)
+                )
+        elif obj_type == 'datatypes' and len(data) > 0:
+            self.extend_datatypes(data)
 
-    def populate_functions(self, schema):
+    def fetch_functions(self, schema):
         """
-        Returns a list of function names
-
-        filter_func is a function that accepts a FunctionMetadata namedtuple
-        and returns a boolean indicating whether that function should be
-        kept or discarded
-
-        Args:
-            schema:
+        This function is used to fecth the list of functions.
+        :param schema:
+        :return:
         """
-
         in_clause = ''
-        funcs = []
+        data = []
 
         if schema:
             in_clause = '\'' + schema + '\''
         else:
             for r in self.search_path:
                 in_clause += '\'' + r + '\','
-
             # Remove extra comma
             if len(in_clause) > 0:
                 in_clause = in_clause[:-1]
 
         query = render_template("/".join([self.sql_path, 'functions.sql']),
-                                schema_names=in_clause,
-                                is_set_returning=True)
+                                schema_names=in_clause)
 
         if self.conn.connected():
             status, res = self.conn.execute_dict(query)
             if status:
-                for record in res['rows']:
-                    funcs.append(record['object_name'])
-
-        return funcs
-
-    def suggest_type(self, full_text, text_before_cursor):
+                for row in res['rows']:
+                    data.append(FunctionMetadata(
+                        row['schema_name'],
+                        row['func_name'],
+                        row['arg_names'].strip('{}').split(',')
+                        if row['arg_names'] is not None
+                        else row['arg_names'],
+                        row['arg_types'].strip('{}').split(',')
+                        if row['arg_types'] is not None
+                        else row['arg_types'],
+                        row['arg_modes'].strip('{}').split(',')
+                        if row['arg_modes'] is not None
+                        else row['arg_modes'],
+                        row['return_type'],
+                        row['is_aggregate'],
+                        row['is_window'],
+                        row['is_set_returning'],
+                        row['arg_defaults'].strip('{}').split(',')
+                        if row['arg_defaults'] is not None
+                        else row['arg_defaults']
+                    ))
+
+        if len(data) > 0:
+            self.extend_functions(data)
+
+    def fetch_columns(self, schemas, obj_type):
         """
-        Takes the full_text that is typed so far and also the text before the
-        cursor to suggest completion type and scope.
-
-        Returns a tuple with a type of entity ('table', 'column' etc) and a
-        scope. A scope for a column category will be a list of tables.
-
-        Args:
-            full_text: Contains complete query
-            text_before_cursor: Contains text before the cursor
+        This function is used to fetch the columns for the given schema name
+        :param schemas:
+        :param obj_type:
+        :return:
         """
 
-        word_before_cursor = last_word(
-            text_before_cursor, include='many_punctuations')
-
-        identifier = None
-
-        def strip_named_query(txt):
-            """
-            This will strip "save named query" command in the beginning of
-            the line:
-            '\ns zzz SELECT * FROM abc'   -> 'SELECT * FROM abc'
-            '  \ns zzz SELECT * FROM abc' -> 'SELECT * FROM abc'
-
-            Args:
-                txt:
-            """
-
-            pattern = re.compile(r'^\s*\\ns\s+[A-z0-9\-_]+\s+')
-            if pattern.match(txt):
-                txt = pattern.sub('', txt)
-            return txt
-
-        full_text = strip_named_query(full_text)
-        text_before_cursor = strip_named_query(text_before_cursor)
-
-        # If we've partially typed a word then word_before_cursor won't be an
-        # empty string. In that case we want to remove the partially typed
-        # string before sending it to the sqlparser. Otherwise the last token
-        # will always be the partially typed string which renders the smart
-        # completion useless because it will always return the list of
-        # keywords as completion.
-        if word_before_cursor:
-            if word_before_cursor[-1] == '(' or word_before_cursor[0] == '\\':
-                parsed = sqlparse.parse(text_before_cursor)
-            else:
-                parsed = sqlparse.parse(
-                    text_before_cursor[:-len(word_before_cursor)])
-
-                identifier = parse_partial_identifier(word_before_cursor)
-        else:
-            parsed = sqlparse.parse(text_before_cursor)
-
-        statement = None
-        if len(parsed) > 1:
-            # Multiple statements being edited -- isolate the current one by
-            # cumulatively summing statement lengths to find the one that
-            # bounds the current position
-            current_pos = len(text_before_cursor)
-            stmt_start, stmt_end = 0, 0
-
-            for statement in parsed:
-                stmt_len = len(statement.to_unicode())
-                stmt_start, stmt_end = stmt_end, stmt_end + stmt_len
-
-                if stmt_end >= current_pos:
-                    break
-
-            text_before_cursor = full_text[stmt_start:current_pos]
-            full_text = full_text[stmt_start:]
-        elif parsed:
-            # A single statement
-            statement = parsed[0]
-        else:
-            # The empty string
-            statement = None
-
-        last_token = statement and statement.token_prev(
-            len(statement.tokens)
-        ) or ''
-
-        return self.suggest_based_on_last_token(
-            last_token, text_before_cursor, full_text, identifier
-        )
-
-    def suggest_based_on_last_token(self, token, text_before_cursor, full_text,
-                                    identifier):
-        # New version of sqlparse sends tuple, we need to make it
-        # compatible with our logic
-        if isinstance(token, tuple) and len(token) > 1:
-            token = token[1]
-
-        if isinstance(token, string_types):
-            token_v = token.lower()
-        elif isinstance(token, Comparison):
-            # If 'token' is a Comparison type such as
-            # 'select * FROM abc a JOIN def d ON a.id = d.'. Then calling
-            # token.value on the comparison type will only return the lhs of
-            # the comparison. In this case a.id. So we need to do token.tokens
-            # to get both sides of the comparison and pick the last token out
-            # of that list.
-            token_v = token.tokens[-1].value.lower()
-        elif isinstance(token, Where):
-            # sqlparse groups all tokens from the where clause into a single
-            # token list. This means that token.value may be something like
-            # 'where foo > 5 and '. We need to look "inside" token.tokens to
-            # handle suggestions in complicated where clauses correctly
-            prev_keyword, text_before_cursor = find_prev_keyword(
-                text_before_cursor
-            )
-            return self.suggest_based_on_last_token(
-                prev_keyword, text_before_cursor, full_text, identifier
-            )
-        elif isinstance(token, Identifier):
-            # If the previous token is an identifier, we can suggest datatypes
-            # if we're in a parenthesized column/field list, e.g.:
-            #       CREATE TABLE foo (Identifier <CURSOR>
-            #       CREATE FUNCTION foo (Identifier <CURSOR>
-            # If we're not in a parenthesized list, the most likely scenario
-            # is the user is about to specify an alias, e.g.:
-            #       SELECT Identifier <CURSOR>
-            #       SELECT foo FROM Identifier <CURSOR>
-            prev_keyword, _ = find_prev_keyword(text_before_cursor)
-            if prev_keyword and prev_keyword.value == '(':
-                # Suggest datatypes
-                return self.suggest_based_on_last_token(
-                    'type', text_before_cursor, full_text, identifier
-                )
-            else:
-                return Keyword(),
-        else:
-            token_v = token.value.lower()
-
-        if not token:
-            return Keyword(),
-        elif token_v.endswith('('):
-            p = sqlparse.parse(text_before_cursor)[0]
-
-            if p.tokens and isinstance(p.tokens[-1], Where):
-                # Four possibilities:
-                #  1 - Parenthesized clause like "WHERE foo AND ("
-                #        Suggest columns/functions
-                #  2 - Function call like "WHERE foo("
-                #        Suggest columns/functions
-                #  3 - Subquery expression like "WHERE EXISTS ("
-                #        Suggest keywords, in order to do a subquery
-                #  4 - Subquery OR array comparison like "WHERE foo = ANY("
-                #        Suggest columns/functions AND keywords. (If we wanted
-                # to be really fancy, we could suggest only array-typed
-                # columns)
-
-                column_suggestions = self.suggest_based_on_last_token(
-                    'where', text_before_cursor, full_text, identifier
-                )
-
-                # Check for a subquery expression (cases 3 & 4)
-                where = p.tokens[-1]
-                prev_tok = where.token_prev(len(where.tokens) - 1)
-
-                if isinstance(prev_tok, Comparison):
-                    # e.g. "SELECT foo FROM bar WHERE foo = ANY("
-                    prev_tok = prev_tok.tokens[-1]
-
-                prev_tok = prev_tok.value.lower()
-                if prev_tok == 'exists':
-                    return Keyword(),
-                else:
-                    return column_suggestions
-
-            # Get the token before the parens
-            prev_tok = p.token_prev(len(p.tokens) - 1)
-            if prev_tok and prev_tok.value and \
-                    prev_tok.value.lower() == 'using':
-                # tbl1 INNER JOIN tbl2 USING (col1, col2)
-                tables = extract_tables(full_text)
-
-                # suggest columns that are present in more than one table
-                return Column(tables=tables, drop_unique=True),
-
-            elif p.token_first().value.lower() == 'select':
-                # If the lparen is preceeded by a space chances are we're
-                # about to do a sub-select.
-                if last_word(text_before_cursor,
-                             'all_punctuations').startswith('('):
-                    return Keyword(),
-            # We're probably in a function argument list
-            return Column(tables=extract_tables(full_text)),
-        elif token_v in ('set', 'by', 'distinct'):
-            return Column(tables=extract_tables(full_text)),
-        elif token_v in ('select', 'where', 'having'):
-            # Check for a table alias or schema qualification
-            parent = (identifier and identifier.get_parent_name()) or []
-
-            if parent:
-                tables = extract_tables(full_text)
-                tables = tuple(t for t in tables if self.identifies(parent, t))
-                return (Column(tables=tables),
-                        Table(schema=parent),
-                        View(schema=parent),
-                        Function(schema=parent),)
-            else:
-                return (Column(tables=extract_tables(full_text)),
-                        Function(schema=None),
-                        Keyword(),)
-
-        elif (token_v.endswith('join') and token.is_keyword) or \
-                (token_v in ('copy', 'from', 'update', 'into',
-                             'describe', 'truncate')):
-
-            schema = (identifier and identifier.get_parent_name()) or None
-
-            # Suggest tables from either the currently-selected schema or the
-            # public schema if no schema has been specified
-            suggest = [Table(schema=schema)]
-
-            if not schema:
-                # Suggest schemas
-                suggest.insert(0, Schema())
-
-            # Only tables can be TRUNCATED, otherwise suggest views
-            if token_v != 'truncate':
-                suggest.append(View(schema=schema))
-
-            # Suggest set-returning functions in the FROM clause
-            if token_v == 'from' or \
-                    (token_v.endswith('join') and token.is_keyword):
-                suggest.append(
-                    Function(schema=schema, filter='is_set_returning')
-                )
-
-            return tuple(suggest)
-
-        elif token_v in ('table', 'view', 'function'):
-            # E.g. 'DROP FUNCTION <funcname>', 'ALTER TABLE <tablname>'
-            rel_type = {'table': Table, 'view': View,
-                        'function': Function}[token_v]
-            schema = (identifier and identifier.get_parent_name()) or None
-            if schema:
-                return rel_type(schema=schema),
-            else:
-                return Schema(), rel_type(schema=schema)
-        elif token_v == 'on':
-            tables = extract_tables(full_text)  # [(schema, table, alias), ...]
-            parent = (identifier and identifier.get_parent_name()) or None
-            if parent:
-                # "ON parent.<suggestion>"
-                # parent can be either a schema name or table alias
-                tables = tuple(t for t in tables if self.identifies(parent, t))
-                return (Column(tables=tables),
-                        Table(schema=parent),
-                        View(schema=parent),
-                        Function(schema=parent))
-            else:
-                # ON <suggestion>
-                # Use table alias if there is one, otherwise the table name
-                aliases = tuple(t.alias or t.name for t in tables)
-                return Alias(aliases=aliases),
-
-        elif token_v in ('c', 'use', 'database', 'template'):
-            # "\c <db", "use <db>", "DROP DATABASE <db>",
-            # "CREATE DATABASE <newdb> WITH TEMPLATE <db>"
-            return Database(),
-        elif token_v == 'schema':
-            # DROP SCHEMA schema_name
-            return Schema(),
-        elif token_v.endswith(',') or token_v in ('=', 'and', 'or'):
-            prev_keyword, text_before_cursor = find_prev_keyword(
-                text_before_cursor)
-            if prev_keyword:
-                return self.suggest_based_on_last_token(
-                    prev_keyword, text_before_cursor, full_text, identifier)
-            else:
-                return ()
-        elif token_v in ('type', '::'):
-            #   ALTER TABLE foo SET DATA TYPE bar
-            #   SELECT foo::bar
-            # Note that tables are a form of composite type in postgresql, so
-            # they're suggested here as well
-            schema = (identifier and identifier.get_parent_name()) or None
-            suggestions = [Datatype(schema=schema),
-                           Table(schema=schema)]
-            if not schema:
-                suggestions.append(Schema())
-            return tuple(suggestions)
-        else:
-            return Keyword(),
-
-    def identifies(self, id, ref):
+        data = []
+        query = render_template("/".join([self.sql_path, 'columns.sql']),
+                                schema_names=schemas,
+                                object_name='table')
+        if obj_type == 'views':
+            query = render_template("/".join([self.sql_path, 'columns.sql']),
+                                    schema_names=schemas,
+                                    object_name='view')
+        if self.conn.connected():
+            status, res = self.conn.execute_dict(query)
+            if status:
+                for row in res['rows']:
+                    data.append((
+                        row['schema_name'], row['table_name'],
+                        row['column_name'], row['type_name'],
+                        row['has_default'], row['default']
+                    ))
+        return data
+
+    def fetch_foreign_keys(self, schemas, obj_type):
         """
-        Returns true if string `id` matches TableReference `ref`
-
-        Args:
-            id:
-            ref:
+        This function is used to fetch the foreign_keys for the given
+        schema name
+        :param schemas:
+        :param obj_type:
+        :return:
         """
-        return id == ref.alias or id == ref.name or (
-            ref.schema and (id == ref.schema + '.' + ref.name))
+
+        data = []
+        query = render_template("/".join([self.sql_path, 'foreign_keys.sql']),
+                                schema_names=schemas)
+
+        if self.conn.connected():
+            status, res = self.conn.execute_dict(query)
+            if status:
+                for row in res['rows']:
+                    data.append(ForeignKey(
+                        row['parentschema'], row['parenttable'],
+                        row['parentcolumn'], row['childschema'],
+                        row['childtable'], row['childcolumn']
+                    ))
+        return data
diff --git a/web/pgadmin/utils/sqlautocomplete/parseutils.py b/web/pgadmin/utils/sqlautocomplete/parseutils.py
index b08a392..85257b0 100644
--- a/web/pgadmin/utils/sqlautocomplete/parseutils.py
+++ b/web/pgadmin/utils/sqlautocomplete/parseutils.py
@@ -73,7 +73,7 @@ TableReference = namedtuple(
 # This code is borrowed from sqlparse example script.
 # <url>
 def is_subselect(parsed):
-    if not parsed.is_group:
+    if not parsed.is_group():
         return False
     sql_type = ('SELECT', 'INSERT', 'UPDATE', 'CREATE', 'DELETE')
     for item in parsed.tokens:
@@ -104,7 +104,7 @@ def extract_from_part(parsed, stop_at_punctuation=True):
             # condition. So we need to ignore the keyword JOIN and its
             # variants INNER JOIN, FULL OUTER JOIN, etc.
             elif item.ttype is Keyword and (
-                    not item.value.upper() == 'FROM') and (
+                not item.value.upper() == 'FROM') and (
                     not item.value.upper().endswith('JOIN')):
                 tbl_prefix_seen = False
             else:
